    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ----------------
    028     * ArrowNeedle.java
    029     * ----------------
    030     * (C) Copyright 2002-2008, by the Australian Antarctic Division and
    031     *                          Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * Changes:
    037     * --------
    038     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    039     * 27-Mar-2003 : Implemented Serializable (DG);
    040     * 09-Sep-2003 : Added equals() method (DG);
    041     * 08-Jun-2005 : Implemented Cloneable (DG);
    042     * 22-Nov-2007 : Added hashCode() implementation (DG);
    043     *
    044     */
    045
    046    package org.jfree.chart.needle;
    047
    048    import java.awt.Graphics2D;
    049    import java.awt.Shape;
    050    import java.awt.geom.GeneralPath;
    051    import java.awt.geom.Line2D;
    052    import java.awt.geom.Point2D;
    053    import java.awt.geom.Rectangle2D;
    054    import java.io.Serializable;
    055
    056    import org.jfree.chart.HashUtilities;
    057
    058    /**
    059     * A needle in the shape of an arrow.
    060     */
    061    public class ArrowNeedle extends MeterNeedle
    062                             implements Cloneable, Serializable {
    063
    064        /** For serialization. */
    065        private static final long serialVersionUID = -5334056511213782357L;
    066
    067        /**
    068         * A flag controlling whether or not there is an arrow at the top of the
    069         * needle.
    070         */
    071        private boolean isArrowAtTop = true;
    072
    073        /**
    074         * Constructs a new arrow needle.
    075         *
    076         * @param isArrowAtTop  a flag that controls whether or not there is an
    077         *                      arrow at the top of the needle.
    078         */
    079        public ArrowNeedle(boolean isArrowAtTop) {
    080            this.isArrowAtTop = isArrowAtTop;
    081        }
    082
    083        /**
    084         * Draws the needle.
    085         *
    086         * @param g2  the graphics device.
    087         * @param plotArea  the plot area.
    088         * @param rotate  the rotation point.
    089         * @param angle  the angle.
    090         */
    091        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    092                                  Point2D rotate, double angle) {
    093
    094            Line2D shape = new Line2D.Float();
    095            Shape d = null;
    096
    097            float x = (float) (plotArea.getMinX() +  (plotArea.getWidth() / 2));
    098            float minY = (float) plotArea.getMinY();
    099            float maxY = (float) plotArea.getMaxY();
    100            shape.setLine(x, minY, x, maxY);
    101
    102            GeneralPath shape1 = new GeneralPath();
    103            if (this.isArrowAtTop) {
    104                shape1.moveTo(x, minY);
    105                minY += 4 * getSize();
    106            }
    107            else {
    108                shape1.moveTo(x, maxY);
    109                minY = maxY - 4 * getSize();
    110            }
    111            shape1.lineTo(x + getSize(), minY);
    112            shape1.lineTo(x - getSize(), minY);
    113            shape1.closePath();
    114
    115            if ((rotate != null) && (angle != 0)) {
    116                getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    117                d = getTransform().createTransformedShape(shape);
    118            }
    119            else {
    120                d = shape;
    121            }
    122            defaultDisplay(g2, d);
    123
    124            if ((rotate != null) && (angle != 0)) {
    125                d = getTransform().createTransformedShape(shape1);
    126            }
    127            else {
    128                d = shape1;
    129            }
    130            defaultDisplay(g2, d);
    131
    132        }
    133
    134        /**
    135         * Tests another object for equality with this object.
    136         *
    137         * @param obj  the object to test (<code>null</code> permitted).
    138         *
    139         * @return A boolean.
    140         */
    141        public boolean equals(Object obj) {
    142            if (obj == this) {
    143                return true;
    144            }
    145            if (!(obj instanceof ArrowNeedle)) {
    146                return false;
    147            }
    148            if (!super.equals(obj)) {
    149                return false;
    150            }
    151            ArrowNeedle that = (ArrowNeedle) obj;
    152            if (this.isArrowAtTop != that.isArrowAtTop) {
    153                return false;
    154            }
    155            return true;
    156        }
    157
    158        /**
    159         * Returns a hash code for this instance.
    160         *
    161         * @return A hash code.
    162         */
    163        public int hashCode() {
    164            int result = super.hashCode();
    165            result = HashUtilities.hashCode(result, this.isArrowAtTop);
    166            return result;
    167        }
    168
    169        /**
    170         * Returns a clone of this needle.
    171         *
    172         * @return A clone.
    173         *
    174         * @throws CloneNotSupportedException if the <code>ArrowNeedle</code>
    175         *     cannot be cloned (in theory, this should not happen).
    176         */
    177        public Object clone() throws CloneNotSupportedException {
    178            return super.clone();
    179        }
    180
    181    }